function out = Decoder(input, r)
%input=[1     1     0     1     1     0     0     1     0     1     1     0];
%r='2/3';

out=[];

%Вкалывание
switch r
    case '1/2'
        steal = [1];
    case '2/3'
        steal = [1 1 1 0];      
    case '3/4'
        steal = [1 1 1 0 0 1]; 
    case '4/5'
        steal = [1 1 1 0 1 0 1 0]; 
    case '5/6'
        steal = [1 1 1 0 0 1 1 0 0 1];  
end
ones = sum(steal);

re_punctured=[];

for i = 1:ones:length(input)
        % Получение среза битов
        bit_slice = input(i:min(i + ones - 1, length(input)));
        re_punctured_slice = zeros(1, length(steal));
        
        k = 1;
        for j = 1:length(steal)
            if steal(j) == 1
                if k <= length(bit_slice)
                    re_punctured_slice(j) = bit_slice(k);
                    k = k + 1;
                end
            else
                re_punctured_slice(j) = 8;
            end
        end

        re_punctured = [re_punctured, re_punctured_slice];
    end

re_punctured

% 0     1     1     1     1     0 
% 0     0     1     1     1     0     0     1     1     0     0     1
% 0     0     1     0     0     1     0     1
% 0     0     0     1     0     0     0     1     0     0     0     1

%G = [1 0 1 1 0 1 1; 1 1 1 1 0 0 1];

g1 = [1 0 1 1 0 1 1]; % g0 = 133(8)
g2 = [1 1 1 1 0 0 1]; % g1 = 171(8)

trellis = struct('next_state', [], 'output', []);

for state = 0:63

        register_bits = bitget(state, 6:-1:1);
        for input_bit = 0:1

            nstate = bitshift(state, -1) + input_bit * 32;

            new_register_bits = [input_bit, register_bits];

            output_A = mod(sum(new_register_bits.*g1), 2);
            output_B = mod(sum(new_register_bits.*g2), 2);

            trellis(state+1, input_bit+1).next_state = nstate;
            trellis(state+1, input_bit+1).output = [output_A, output_B];
        end
        
    end

k=length(re_punctured)/2;

matrix = inf(64, k+1);
matrix(1, 1) = 0;

pstate = zeros(64, k+1);


for t = 1:k
    for state = 1:64
        % Проверка переходов для каждого состояния
        for input = 0:1
            nstate = trellis(state, input + 1).next_state;
            output = trellis(state, input + 1).output;

            branch_metric = 0;

            out2=re_punctured(2*t-1:2*t);
            index = out2 ~= 8;
            out2(index);

            branch_metric = sum(xor(out2(index), output(index)));
            
            new_metric = matrix(state, t) + branch_metric;

                % Обновление метрики и пути, если нашли лучший путь
            if new_metric < matrix(nstate+1, t+1)
                matrix(nstate+1, t+1) = new_metric;
                pstate(nstate+1, t+1) = state - 1;
            end
        end
    end
end

% Обратное отслеживание пути для получения декодированных битов
decoded_bits = zeros(1, k);
[~, state] = min(matrix(:, end)); % Старт с наилучшего состояния
for t = k:-1:1
    prev = pstate(state, t+1);
    % Проверяем оба возможных перехода из предыдущего состояния
    for input_bit = 0:1
        if trellis(prev+1, input_bit+1).next_state == state-1
            decoded_bits(t) = input_bit;
            break;  % Переход найден, выходим из цикла
        end
    end
    state = prev + 1;
end


out=decoded_bits;

end