function out = demapping(input,order, type, sigma)

%input=[ 0.4629 - 1.0801i   0.7715 - 0.7715i ];
%order=6;
%type = 'approx';
%sigma = 0.05;

switch order
        case 1  %BPSK
            k=1;
            constellation = [-1 1]/k;
        case 2  %QPSK
            k=sqrt(2);
            constellation = [-1-1i, 1-1i, -1+1i, 1+1i]/k;
        case 4 % %16QAM
            k=sqrt(10);
            constellation = [-3-3i, -3-1i, -3+3i, -3+1i, -1-3i, -1-1i, -1+3i, -1+1i, 3-3i, 3-1i, 3+3i, 3+1i, 1-3i, 1-1i, 1+3i, 1+1i]/k;
        case 6 %64QAM
            k=sqrt(42);
            constellation = [-7-7i, -7-5i, -7-1i, -7-3i, -7+7i, -7+5i, -7+1i, -7+3i,  -5-7i, -5-5i, -5-1i, -5-3i, -5+7i, -5+5i, -5+1i, -5+3i,  -1-7i, -1-5i, -1-1i, -1-3i, -1+7i, -1+5i, -1+1i, -1+3i,  -3-7i, -3-5i, -3-1i, -3-3i, -3+7i, -3+5i, -3+1i, -3+3i,  +7-7i, +7-5i, +7-1i, +7-3i, +7+7i, +7+5i, +7+1i, +7+3i,  +5-7i, +5-5i, +5-1i, +5-3i, +5+7i, +5+5i, +5+1i, +5+3i,  +1-7i, +1-5i, +1-1i, +1-3i, +1+7i, +1+5i, +1+1i, +1+3i,  +3-7i, +3-5i, +3-1i, +3-3i, +3+7i, +3+5i, +3+1i, +3+3i]/k;
    end

    %constellation

out=[];


switch type
        case 'hard'
            for i = 1:length(input)
                distances = abs(input(i) - constellation).^2;
                [~, minIdx] = min(distances);
                out = [out, de2bi(minIdx-1, order, 'left-msb')];
            end
            
        case 'soft'
            for i = 1:length(input)
                s = input(i); 
                for bitIdx = 1:order
                    numSum = 0; 
                    denSum = 0; 
                    for k = 1:length(constellation)
                        bitValue = bitget(k-1, order - bitIdx + 1);
                        probability = (1 / (sqrt(2 * pi) * sigma)) * exp(-abs(s - constellation(k))^2 / (2 * sigma^2));
                        if bitValue == 0
                            numSum = numSum + probability; 
                        else
                            denSum = denSum + probability;
                        end
                    end
                    LLR((i-1)*order + bitIdx) = log(numSum / denSum);
                end
            end
            for i = 1:length(LLR)
                if LLR(i)>0
                    out = [out 0];
                else
                    out = [out 1];
                end
            end

        case 'approx'
            for i = 1:length(input)
                s = input(i);
                for bitIdx = 1:order
                    minDist0 = inf;
                    minDist1 = inf;
                    for k = 1:length(constellation)
                        dist = abs(s - constellation(k))^2;
                        bitValue = bitget(k-1, order - bitIdx + 1); 
                        if bitValue == 0
                            minDist0 = min(minDist0, dist);
                        else
                            minDist1 = min(minDist1, dist);
                        end
                    end
                    LLR((i-1)*order + bitIdx) = -(1 / (2 * sigma^2)) * (minDist0 - minDist1);
                end
            end
            for i = 1:length(LLR)
                if LLR(i)>0
                    out = [out 0];
                else
                    out = [out 1];
                end
            end
end


end




